### Eclipse Workspace Patch 1.0
#P fluid-components
Index: src/webapp/fluid-components/js/fluid/uploader/DemoUploadManager.js
===================================================================
--- src/webapp/fluid-components/js/fluid/uploader/DemoUploadManager.js	(revision 6503)
+++ src/webapp/fluid-components/js/fluid/uploader/DemoUploadManager.js	(working copy)
@@ -86,6 +86,7 @@
                                      fluid.uploader.errorConstants.UPLOAD_STOPPED, 
                                      "The demo upload was paused by the user.");
         finishAndContinueOrCleanup(that, file);
+        that.events.onUploadStop.fire();
     };
     
     var setupDemoUploadManager = function (that) {
Index: src/webapp/fluid-components/js/fluid/uploader/Uploader.js
===================================================================
--- src/webapp/fluid-components/js/fluid/uploader/Uploader.js	(revision 6503)
+++ src/webapp/fluid-components/js/fluid/uploader/Uploader.js	(working copy)
@@ -405,6 +405,7 @@
         disableElement(that, that.locate("browseButton"));
         enableElement(that, that.locate("pauseButton"));
         showElement(that, that.locate("pauseButton"));
+        that.locate(that.options.focusWithEvent.afterUploadStart).focus();
     };    
     
     var renderUploadTotalMessage = function (that) {
@@ -465,7 +466,8 @@
         if (that.uploadManager.queue.getReadyFiles().length > 0) {
             setStateLoaded(that);
             renderUploadTotalMessage(that);
-        } 
+            that.locate(that.options.focusWithEvent.afterFileDialog).focus();  
+        }
     };
     
     var updateStateAfterFileRemoval = function (that) {
@@ -501,7 +503,11 @@
         that.events.onUploadStart.addListener(function () {
             setStateUploading(that);
         });
-
+        
+        that.events.onUploadStop.addListener(function () {
+            that.locate(that.options.focusWithEvent.afterUploadStop).focus();
+        });
+        
         that.events.onFileProgress.addListener(function () {
             updateTotalProgress(that); 
         });
@@ -644,6 +650,13 @@
             totalFileStatusText: ".total-file-progress",
             instructions: ".fl-uploader-browse-instructions"
         },
+ 
+        // event listeners must already be implemented to use these options
+        focusWithEvent: {
+            afterFileDialog: "uploadButton",
+            afterUploadStart: "pauseButton",
+            afterUploadStop: "uploadButton"
+        },
         
         styles: {
             disabled: "disabled",
